#!/usr/bin/perl -w
use strict;

BEGIN {
	use lib qw( t/ );
	print "1..12\n";
}

use object_list;

my $t = 1;
my ($h, $s, $err);

##-----  empty new with single inheritance  -----
## create empty Helicopter
$h = Helicopter->new();

## check ref of new Helicopter
print "not "	unless ref($h) eq 'Helicopter';
print "ok @{[ $t++ ]}\n";

## check 'class' field of new Helicopter
print "not "	unless $h->{class} eq 'Helicopter';
print "ok @{[ $t++ ]}\n";

## assign values of attributes then check them
$h->{name}				= 'Whirly Bird';
$h->{owner}				= 25;
$h->{ceiling}			= 7500;
$h->{lift_capacity}		= 800;
$err = 0;
$err++ if $h->{name}			ne 'Whirly Bird';
$err++ if $h->{owner}			!= 25;
$err++ if $h->{ceiling}			!= 7500;
$err++ if $h->{lift_capacity}	!= 800;
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  empty new with multiple inheritance  -----
## create empty Seaplane
$s = Seaplane->new();

## check ref of new Seaplane
print "not "	unless ref($s) eq 'Seaplane';
print "ok @{[ $t++ ]}\n";

## check 'class' field of new Seaplane
print "not "	unless $s->{class} eq 'Seaplane';
print "ok @{[ $t++ ]}\n";

## assign values of attributes then check them
$s->{name}				= 'PuddleJumper';
$s->{owner}				= 20;
$s->{ceiling}			= 9000;
$s->{wingspan}			= 36;
$s->{min_depth}			= 2.5;
$s->{anchor}			= 17;
$s->{max_wave_height}	= 2;
$err = 0;
$err++ if $s->{name}			ne 'PuddleJumper';
$err++ if $s->{owner}			!= 20;
$err++ if $s->{ceiling}			!= 9000;
$err++ if $s->{wingspan}		!= 36;
$err++ if $s->{min_depth}		!= 2.5;
$err++ if $s->{anchor}			!= 17;
$err++ if $s->{max_wave_height}	!= 2;
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  initialized new with single inheritance  -----
## create initialized Helicopter
$h = Helicopter->new( {	name			=> 'Whirly Bird',
						owner			=> 25,
						ceiling			=> 7500,
						lift_capacity	=> 800
					} );

## check ref of new Helicopter
print "not "	unless ref($h) eq 'Helicopter';
print "ok @{[ $t++ ]}\n";

## check 'class' field of new Helicopter
print "not "	unless $h->{class} eq 'Helicopter';
print "ok @{[ $t++ ]}\n";

## check that attributes were assigned correctly
$err = 0;
$err++ if $h->{name}			ne 'Whirly Bird';
$err++ if $h->{owner}			!= 25;
$err++ if $h->{ceiling}			!= 7500;
$err++ if $h->{lift_capacity}	!= 800;
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  initialized new with multiple inheritance  -----
## create initialized Seaplane
$s = Seaplane->new( {	name			=> 'PuddleJumper',
						owner			=> 20,
						ceiling			=> 9000,
						wingspan		=> 36,
						min_depth		=> 2.5,
						anchor			=> 17,
						max_wave_height	=> 2
					} );

## check ref of new Seaplane
print "not "	unless ref($s) eq 'Seaplane';
print "ok @{[ $t++ ]}\n";

## check 'class' field of new Seaplane
print "not "	unless $s->{class} eq 'Seaplane';
print "ok @{[ $t++ ]}\n";

## check that attributes were assigned correctly
$err = 0;
$err++ if $s->{name}			ne 'PuddleJumper';
$err++ if $s->{owner}			!= 20;
$err++ if $s->{ceiling}			!= 9000;
$err++ if $s->{wingspan}		!= 36;
$err++ if $s->{min_depth}		!= 2.5;
$err++ if $s->{anchor}			!= 17;
$err++ if $s->{max_wave_height}	!= 2;
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

1;
