#!/usr/bin/perl -w

use strict;

BEGIN {
	use lib qw( t/ );
	print "1..8\n";
}

use object_list;

require 'recreate_tables.pl';
require 'fill_tables.pl';

my $t = 1;
my ($h, $s, $err);

##-----  single inheritance simple fetch  -----
## fetch a Helicopter
$h = Helicopter->fetch(8);

## check ref of new Helicopter
print "not "	unless ref($h) eq 'Helicopter';
print "ok @{[ $t++ ]}\n";

## check 'class' field of new Helicopter
print "not "	unless $h->{class} eq 'Helicopter';
print "ok @{[ $t++ ]}\n";

## check attribute values
$err = 0;
$err++ if $h->{name}			ne 'Whirly Bird';
$err++ if $h->{owner}			!= 25;
$err++ if $h->{ceiling}			!= 7500;
$err++ if $h->{lift_capacity}	!= 800;
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  multiple inheritance simple fetch  -----
## fetch a Seaplane
$s = Seaplane->fetch(12);

## check ref of new Seaplane
print "not "	unless ref($s) eq 'Seaplane';
print "ok @{[ $t++ ]}\n";

## check 'class' field of new Seaplane
print "not "	unless $s->{class} eq 'Seaplane';
print "ok @{[ $t++ ]}\n";

## check attribute values
$err = 0;
$err++ if $s->{name}			ne 'PuddleJumper';
$err++ if $s->{owner}			!= 20;
$err++ if $s->{ceiling}			!= 9000;
$err++ if $s->{wingspan}		!= 36;
$err++ if $s->{min_depth}		!= 2.5;
# $err++ if $s->{anchor}			!= 17;
$err++ if $s->{max_wave_height}	!= 2;
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  fetch_group  -----
## get all vehicles owned by Bob
my $Bobs_vehicles = Vehicle->fetch_group({where => 'owner = ?', value  => [ 20 ]});
print "not "	unless @$Bobs_vehicles == 3;
print "ok @{[ $t++ ]}\n";

$err = 0;
foreach my $v (@$Bobs_vehicles) {
	if ($v->id == 5)  {	$err++ unless ref $v eq 'Boat'; 	next; }
	if ($v->id == 7)  {	$err++ unless ref $v eq 'Aircraft';	next; }
	if ($v->id == 12) {	$err++ unless ref $v eq 'Seaplane';	next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

1;
