#!/usr/bin/perl -w

use strict;

BEGIN {
	use lib qw( t/ );
	print "1..4\n";
}

use object_list;

require 'recreate_tables.pl';
require 'fill_tables.pl';

my $t = 1;
my ($h, $s, $err);

##-----  single inheritance remove  -----
## fetch a Helicopter
$h = Helicopter->fetch(8);
print "not "	unless $h->remove;
print "ok @{[ $t++ ]}\n";

## check tables to make sure it's gone
$err = 0;
foreach my $class ( qw(Helicopter Aircraft Vehicle ESPOPS::Object) ) {
	my $args = {	from => [ $class->base_table ],
					select => [ 'count(*)'],
					where => $class->id_clause(8, undef, undef),
					return => 'single'
				};
	my $row = eval { $class->db_select($args);	};
	$err++ unless $row->[0] == 0;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  multiple inheritance remove  -----
## fetch a Seaplane
$s = Seaplane->fetch(12);
print "not "	unless $s->remove;
print "ok @{[ $t++ ]}\n";

## check tables to make sure it's gone
$err = 0;
foreach my $class ( qw(Seaplane FixedWing Aircraft Vehicle Boat ESPOPS::Object) ) {
	my $args = {	from => [ $class->base_table ],
					select => [ 'COUNT(*)'],
					where => $class->id_clause(12, undef, undef),
					return => 'single'
				};
	my $row = eval { $class->db_select($args);	};
	$err++ unless $row->[0] == 0;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

1;
