#!/usr/bin/perl -w

use strict;

BEGIN {
	use lib qw( t/ );
	print "1..7\n";
}

use object_list;

require 'recreate_tables.pl';
require 'fill_tables.pl';

my $t = 1;
my ($err, $c, $clubs, $p, $persons);

##-----  fetch methods  -----
$p = Person->fetch(20);
$clubs = $p->ClubAlias;
$err = 2;
foreach $c (@$clubs) {
	if ($c->id == 26)  { $err--; next; }
	if ($c->id == 27)  { $err--; next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

$c = Club->fetch(26);
$persons = $c->PersonAlias;
$err = 3;
foreach $p (@$persons) {
	if ($p->id == 20)  { $err--; next; }
	if ($p->id == 21)  { $err--; next; }
	if ($p->id == 24)  { $err--; next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  add methods  -----
$p = Person->fetch(20);
$p->ClubAlias_add([28]);
$clubs = $p->ClubAlias;
$err = 3;
foreach $c (@$clubs) {
	if ($c->id == 26)  { $err--; next; }
	if ($c->id == 27)  { $err--; next; }
	if ($c->id == 28)  { $err--; next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

$c = Club->fetch(26);
$c->PersonAlias_add( [22,25] );
$persons = $c->PersonAlias;
$err = 5;
foreach $p (@$persons) {
	if ($p->id == 20)  { $err--; next; }
	if ($p->id == 21)  { $err--; next; }
	if ($p->id == 24)  { $err--; next; }
	if ($p->id == 22)  { $err--; next; }
	if ($p->id == 25)  { $err--; next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  remove methods  -----
$p = Person->fetch(20);
$p->ClubAlias_remove([28]);
$clubs = $p->ClubAlias;
$err = 2;
foreach $c (@$clubs) {
	if ($c->id == 26)  { $err--; next; }
	if ($c->id == 27)  { $err--; next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

$c = Club->fetch(26);
$c->PersonAlias_remove( [22,25] );
$persons = $c->PersonAlias;
$err = 3;
foreach $p (@$persons) {
	if ($p->id == 20)  { $err--; next; }
	if ($p->id == 21)  { $err--; next; }
	if ($p->id == 24)  { $err--; next; }
	$err++;
}
print "not "	if $err;
print "ok @{[ $t++ ]}\n";

##-----  auto-removal of linking entries  -----
$c->remove;
my $args = {	from => [ 'ClubMembers' ],
				select => [ 'COUNT(*)'],
				where => 'club_id = 26',
				return => 'single'
			};
my $row = eval { ClubMembers->db_select($args); };
print "not "	if $row->[0];
print "ok @{[ $t++ ]}\n";

1;

