#!/usr/bin/perl -w

use strict;

BEGIN {
	use lib qw( t/ );
	print "1..4\n";
}

use object_list;

require 'recreate_tables.pl';
require 'fill_tables.pl';

my $t = 0;
my ($h, $s, $err);

##-----  single inheritance clone --
$h = Helicopter->fetch(8);
$s = $h->clone;

## check attributes before saving
$err = 0;
$err++ if (	$s eq $h ||
		$s->{name} ne 'Whirly Bird' ||
		$s->{owner} != 	25 ||
		$s->{ceiling} != 7500 ||
		$s->{lift_capacity} != 800
	);
print $err ? "not ok @{[ ++$t ]}\n" : "ok @{[ ++$t ]}\n";

## and after saving and re-fetching
$s->save;
$s = Helicopter->fetch($s->id);
$err = 0;
$err++ if (	$s eq $h ||
		$s->{name} ne 'Whirly Bird' ||
		$s->{owner} != 	25 ||
		$s->{ceiling} != 7500 ||
		$s->{lift_capacity} != 800
	);
print $err ? "not ok @{[ ++$t ]}\n" : "ok @{[ ++$t ]}\n";
undef $h;

##-- multiple inheritance clone --
$s = Seaplane->fetch(12);
$h = $s->clone;

## check attributes before saving
$err = 0;
$err++ if (	$s eq $h ||
		$h->{name} ne 'PuddleJumper' ||
		$h->{owner} != 20 ||
		$h->{ceiling} != 9000 ||
		$h->{wingspan} != 36 ||
		$h->{min_depth} != 2.5 ||
		$h->{anchor}->{id} != 17 ||
		$h->{max_wave_height} != 2
	);
print $err ? "not ok @{[ ++$t ]}\n" : "ok @{[ ++$t ]}\n";

## and after saving and re-fetching
$h->save;
$h = Seaplane->fetch($h->id);
$err = 0;
$err++ if (	$s eq $h ||
		$h->{name} ne 'PuddleJumper' ||
		$h->{owner} != 20 ||
		$h->{ceiling} != 9000 ||
		$h->{wingspan} != 36 ||
		$h->{min_depth} != 2.5 ||
		$h->{anchor}->{id} != 17 ||
		$h->{max_wave_height} != 2
	);
print $err ? "not ok @{[ ++$t ]}\n" : "ok @{[ ++$t ]}\n";

1;
