package Person;

use strict;
use vars qw($VERSION @ISA $CONF $TABLE_DEF);

BEGIN {
	$VERSION = sprintf "%d.%03d", q$Revision: 1.11 $ =~ /: (\d+)\.(\d+)/;
	@ISA = qw/ ESPOPS::Object /;
	$CONF = {
		PersonAlias => {
			class			=> 'Person',
			isa				=> \@ISA,
			field			=> [ qw/ person_id name / ],
			as_string_order => [ qw/ person_id class name / ],
			base_table		=> 'Person',
			id_field		=> 'person_id',
			skip_undef		=> [ qw/ name / ],
			links_to		=> { 'Club' => 'ClubMembers' },
			no_security		=> 1,
		},
	};
	$TABLE_DEF = <<SQL;
CREATE TABLE Person (
	person_id	int(11) PRIMARY KEY,
	name		char(255)
)
SQL
}

use ESPOPS::Object;
use Club;

sub list_clubs {
	my $this = shift;
	my $db = $this->global_datasource_handle;
	my $SQL = "select c.name from Club c, ClubMembers z ".
		  "where z.club_id = c.club_id and z.person_id = ".
	          $this->{person_id};
	my $sth = $db->prepare($SQL);
	my $rv = $sth->execute();
	my @clubs;
	my $idx;
	for($idx = 0; $clubs[$idx] = $sth->fetchrow_array; $idx++) { 
		print "$clubs[$idx]\n";
	}
	return;
}

sub list_vehicles {
	my $this = shift;
	my $db = $this->global_datasource_handle;
	my $SQL = "select name from Vehicle ".
		  "where owner = ".$this->{person_id};
	my $sth = $db->prepare($SQL);
	my $rv = $sth->execute();
	my @vehicles;
	my $idx;
	for($idx = 0; $vehicles[$idx] = $sth->fetchrow_array; $idx++) { 
		print "$vehicles[$idx]\n";
	}
	return;
}

__PACKAGE__->config_and_init;

1;
