package Seaplane;

use strict;
use vars qw($VERSION @ISA $CONF $TABLE_DEF);

BEGIN {
	$VERSION = sprintf "%d.%03d", q$Revision: 1.11 $ =~ /: (\d+)\.(\d+)/;
	@ISA = qw/ FixedWing Boat /;
	$CONF = {
		SeaplaneAlias => {
			class			=> 'Seaplane',
			isa				=> \@ISA,
			field			=> [ qw/ id max_wave_height / ],
			as_string_order => [ qw/ id class name owner ceiling wingspan max_wave_height min_depth anchor / ],
			base_table		=> 'Seaplane',
			id_field		=> 'id',
			skip_undef		=> [ qw/ max_wave_height / ],
			no_security		=> 1,
		},
	};
	$TABLE_DEF = <<SQL;
CREATE TABLE Seaplane (
	id				int(11) PRIMARY KEY,
	max_wave_height int(11)
)
SQL
}

use FixedWing;
use Boat;

sub land_on_water {
	my $this = shift;
	print "Splash! Seaplane: " . $this->{name} . " ... lands on water.\n";
}

sub pre_remove_action {
	my $self = shift;
	my $p = shift;
	return $self->Boat::pre_remove_action($p);
}

sub pre_save_action {
	my $self = shift;
	my $p = shift;
	return $self->Boat::pre_save_action($p);
}

sub post_save_action {
	my $self = shift;
	my $p = shift;
	return $self->Boat::post_save_action($p);
}

sub post_fetch_action {
	my $self = shift;
	my $p = shift;
	return $self->Boat::post_fetch_action($p);
}

__PACKAGE__->config_and_init;

1;
