package Vehicle;

use strict;
use vars qw($VERSION @ISA $CONF $TABLE_DEF);

BEGIN {
	$VERSION = sprintf "%d.%03d", q$Revision: 1.9 $ =~ /: (\d+)\.(\d+)/;
	@ISA = qw/ ESPOPS::Object /;
	$CONF = {
		VehicleAlias => {
			class			=> 'Vehicle',
			isa				=> \@ISA,
			field			=> [ qw/ id name owner / ],
			as_string_order => [ qw/ id class name owner / ],
			base_table		=> 'Vehicle',
			id_field		=> 'id',
			has_a			=> { Person => [ 'owner' ] },
			skip_undef		=> [ qw/ name owner / ],
			no_security		=> 1,
		},
	};
	$TABLE_DEF = <<SQL;
CREATE TABLE Vehicle (
	id		 int(11) PRIMARY KEY,
	name	 char(255),
	owner	 int(11)
)
SQL
}

use ESPOPS::Object; 
use Person;

sub do_maintainance {
	my $this = shift;
	print "Maintenance on Vehicle: " . $this->{name} . " ... done.\n";
# 	foreach my $k (keys %$this) {
# 		print "\t" . $k . "\t=\t" . $this->{$x} . "\n";
# 	}
}

__PACKAGE__->config_and_init;

1;
